%The following equations are taken from "The quantum and classical Fano
%parameter q" by Masatomi Iizawa et al. on arix1810.00627

w = (1:5000)/1000;
F = 1; %driving force
w1 = 1.0; % oscillator 1 resonance frequency
w2 = 1.1+0.02j; % oscillator 2 resonance frequency
lambda1 = 0.2; % oscillator 1 damping constant
c = 0.5; % coupling constant
wa = sqrt(w1^2-c^2/(w2^2-w1^2)); %new eigenmode a
wb = sqrt(w2^2+c^2/(w2^2-w1^2)); %new eigenmode b

E_tilde = w.^2-wb^2;
E = 1/(lambda1*w2)*(w2^2-w1^2)^2/c^2*E_tilde;
q = 1/(lambda1*w2)*(w2^2-w1^2);
x1 = (E+q)./(E-j).*F/(w2^2-w1^2);

%figure
yyaxis left
plot(w, abs(x1))
hold on
phi = -angle(x1);

for i = 2:length(w)-1
    if  phi(i+1)-phi(i) > pi
        phi(i+1) = phi(i+1) - 2*pi;
    end
    if phi(i+1)-phi(i) < -pi
        phi(i+1) = phi(i+1) + 2*pi;
    end
end

phi=phi/pi;
phi=phi-min(phi);
yyaxis right
plot(w, phi)
