%The following equations are taken from "The quantum and classical Fano
%parameter q" by Masatomi Iizawa et al. on arix1810.00627

w = 1.5;
F = 1; %driving force
w1 = (1:3000)/500; % oscillator 1 resonance frequency
w2 = (1.1+0.02j)*w1; % oscillator 2 resonance frequency
lambda1 = 0.2*w1; % oscillator 1 damping constant
c = 0.5+w1*0; % coupling constant
for i = 1:length(w1)
    wa(i) = sqrt(w1(i)^2-c(i)^2/(w2(i)^2-w1(i)^2)); %new eigenmode a
    wb(i) = sqrt(w2(i)^2+c(i)^2/(w2(i)^2-w1(i)^2)); %new eigenmode b
    E_tilde(i) = w^2-wb(i)^2;
    E(i) = 1/(lambda1(i)*w2(i))*(w2(i)^2-w1(i)^2)^2/c(i)^2*E_tilde(i);
    q(i) = 1/(lambda1(i)*w2(i))*(w2(i)^2-w1(i)^2);
    x1(i) = (E(i)+q(i))./(E(i)-j).*F/(w2(i)^2-w1(i)^2);
end
%figure
yyaxis left
plot(-w1, abs(x1))
hold on
phi = -angle(x1);
%{
for i = 2:length(w)-1
    if  phi(i+1)-phi(i) > 10*(phi(i)-phi(i-1))
        phi(i+1) = phi(i+1) + 2*pi;
    end
    if phi(i+1)-phi(i) < -10*(phi(i)-phi(i-1))
        phi(i+1) = phi(i+1) - 2*pi;
    end
end
%}
phi=phi/pi;
phi=phi-min(phi);
yyaxis right
plot(-w1, phi)